#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h> /* for inet_aton */
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifndef FORSATABS
#include <fcntl.h> /* for O_WRONLY */
#endif

#include "wrappers.h"
#include "run.h"
#include "filexfer.h"
#include "clocation.h"

extern int debug;


int main(int argc, char **argv) {
	char *location, *req_name, *local_name;
	int socketfd;
	
	debug = 1; 
	if (argc != 4) {
		printf("Use: %s location requested_file wanted_local_filename\n", argv[0]);
		exit(1);
	}

	location = argv[1];
	req_name = argv[2];
	local_name = argv[3];

	
	socketfd = connect_to_location(location);
	if (socketfd == -1) {
		warn("Couldn't connect to %s\n", location);
		exit(1);
	}

	/* FIXME: this should receive an _agent_, and that should
	    handle setting everything appropriately... */
	/* FIXME: change set_inet_origin to take a location, not a host and port */
	recv_file(socketfd, req_name, local_name);
	set_inet_origin("Unknown", 0, req_name, local_name);
	
	wclose(socketfd);

	run_agent(local_name);
	return 0;
}


