#ifndef _COMMON_H
#define _COMMON_H

#include <netinet/in.h> /* struct sockaddr */

int xsocket(int domain, int type, int protocol);
void xbind(int sockfd, struct sockaddr *my_addr, size_t addrlen);
void xlisten(int sockfd, int backlog);
void xconnect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen);
ssize_t rsend(int s, const void *buf, size_t len, int flags);
void show_error_and_exit();
int wclose(int fd);
char *describe_err(int err);
void warn(const char *fmt, ...);

#ifdef FORSATABS
int inet_aton(const char *cp, struct in_addr *inp);
/* the following 3 definitions are incorrect */
int PF_INET = 1;
int EINTR = 1;
int PATH_MAX = 4096;
int nondet_int();
#endif /* FORSATABS */

#define MAX_FILENAME_LENGTH PATH_MAX

int debug; 

#endif /* _COMMON_H */

