#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <arpa/inet.h>

#include "wrappers.h"
#include "clocation.h"
#include "agent.h"


#define INFO_LOCATION "airq"
#define MAX_PRICE_SIZE 30

#define CALLER_LOCATION "airc"

extern int debug;

/* TODO: give location-awareness information here */
int main(int argc, char **argv) {
	int sockfd;
	char msg[MAX_PRICE_SIZE];
	char *parent_location = CALLER_LOCATION;

	debug = 1;
	
	/* connect to a 'malicious' location */
	sockfd = connect_to_location("bad");
	wclose(sockfd);

	sockfd = connect_to_location("airq");
	if (sockfd < 0) {
		report_back_status("Couldn't connect to query the price.\n", 
			parent_location);
		return -1;
	}
	if (recv(sockfd, &msg, MAX_PRICE_SIZE -1, 0) == -1) {
		report_back_status("Connected but couldn't find a price.\n",
			parent_location);
		wclose(sockfd);
		return -1;
	}
	
	if (report_back_status(msg, parent_location) < 0) return -1;
	wclose(sockfd);

	warn("Finished successfully\n");
	return 0;
}

