#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <errno.h>

#include "../../wrappers.h"
#include "../../listener.h"
#include "../../agentxfer.h"

#define MAX_SHOPPING_RESULT_SIZE 200

#define AIRLINE_PORT_1 3000
#define AIRLINE_PORT_2 4000
/* the agents need to know what port to talk to */
#define LISTEN_ON_PORT_STRING "3333"
#define UA_NAME "user_agent.tar.gz"

void mainloop(int sockfd);
int start_agents(void);
int start_receivers(void);

int main(int argc, char **argv) {
	int sockfd;

	/* hack: listen on a fixed port */
	if (argc >= 2) {
		if (strcmp(argv[1], LISTEN_ON_PORT_STRING) != 0) {
			argv[1] = LISTEN_ON_PORT_STRING;
			printf("Changed arguments: listening on port %s\n", LISTEN_ON_PORT_STRING);
		}
	}
	sockfd = init_listener(argc, argv);
	if (start_receivers() == -1) {
		warn("Unable to start at least one of the airline receivers..\n");
	}
	printf("starting agent\n");
	if (start_agents() == -1) {
		warn("Unable to start at least one of the agents..\n");
	}
	printf("starting mainloop\n");
	mainloop(sockfd);
	return 0;
}

void mainloop(int sockfd) {
	ssize_t bytes_read;
	char shopping_result[MAX_SHOPPING_RESULT_SIZE];
	
	while(1) {
		bytes_read = wget_data(sockfd, shopping_result, MAX_SHOPPING_RESULT_SIZE);
		if (bytes_read == -1) {
			warn(describe_err(errno));
			continue;
		}
		printf("%s\n", shopping_result);
	}
}

int start_agents(void) {
	int ret = 0;
	ret |= send_agent_to("loc0", UA_NAME);
	ret |= send_agent_to("loc1", UA_NAME);
	return ret;
}

int start_receivers(void) {
	return 0;
}

