/* The updating agent. 

   Conceptually, it performs an update, but here, it's just
   doing a little bit of file io and networking without
   applying any changes to the system 
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include "wrappers.h"
#include "clocation.h"
#include "agent.h"
#include "genwrapper.h"

#define CALLER_LOCATION "uas"

#define MAX_REPLY_LEN 30

extern int debug;


int main(int argc, char **argv) {
	FILE *fd;
	char update_text[MAX_REPLY_LEN];
	/* the following should be derivable through the run-time api,
 	   but currently isn't */
	char *parent_location = CALLER_LOCATION;
	
	debug = 1;
	memset(update_text, 0, MAX_REPLY_LEN);
	
	if((fd = _wrapper_fopen("/etc/passwd", "r")) != NULL) fclose(fd);

	fd = _wrapper_fopen("update.txt", "r");
	if (fd == NULL) {
		report_back_status("Update agent/capplet: could not open update file, quitting.\n", parent_location);
		return -1;
	}
	
	if (fgets(update_text, MAX_REPLY_LEN - 1, fd) == NULL) {
		report_back_status("Couldn't read update status, quitting!\n", parent_location);
		fclose(fd);
		return -1;
	}
	
	if (report_back_status(update_text, parent_location) < 0) return -1;
	fclose(fd);
	
	warn("Finished successfully!\n");	
	return 0;
}


