#ifndef _WRAPPERS_H
#define _WRAPPERS_H

#include <sys/socket.h>
#include <netinet/in.h> /* struct sockaddr */
#include <arpa/inet.h>


int xsocket(int domain, int type, int protocol);
void xbind(int sockfd, struct sockaddr *my_addr, size_t addrlen);
void xlisten(int sockfd, int backlog);
void xconnect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen);
int connect_to_host_and_port(char *host_ip, int port);
ssize_t rsend(int s, const void *buf, size_t len, int flags);
ssize_t wget_data(int sockfd, char *buf, size_t size);
char *wrecv_nullterminated(int connfd, int buf_size);
void show_error_and_exit();
int wclose(int fd);
char *describe_err(int err);
void warn(const char *fmt, ...);
void free_after_dyn_not_recognized_by_satabs(void *a_ptr);

#ifdef FORSATABS
/* the following definitions are incorrect */
int EINTR = 1;
int PATH_MAX = 4096;
#endif /* FORSATABS */

#define MAX_FILENAME_LENGTH PATH_MAX
#define MAX_LOCATION_LEN 200

int debug; 

#endif /*_WRAPPERS_H */

