/* todo: make this a command-line argument? */
#define UC_LOCATION "uc_location"

/* connect to a server, pass it a location, and then
 * loop forever, waiting for updates and running them.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>

#include "wrappers.h"
#include "filexfer.h"
#include "push_recv_core.h"

extern int debug;


int main(int argc, char **argv) {
	char *filename, *uhost;
	int uport, lport, socketfd, retval;
	struct sockaddr_in si;

	if (argc != 4) {
		printf("Use: %s update_host update_port listen_port\n", argv[0]);
		exit(1);
	}
	
	debug = 1;
	
	uhost = argv[1];
	uport = atoi(argv[2]);
	lport = atoi(argv[3]);
	
	si.sin_family = AF_INET;
	si.sin_port = htons(uport);
	inet_aton(uhost, &si.sin_addr); /* FIXME: accept host NAMES too */
	memset(&(si.sin_zero), '\0', 8);

	socketfd = xsocket(PF_INET, SOCK_STREAM, 0);
	xconnect(socketfd, (const struct sockaddr *) &si, sizeof(si));
	/* write xsend */
	retval = send(socketfd, UC_LOCATION, strlen(UC_LOCATION) + 1, 0);
	if (retval == -1) {
		warn("Unable to tell the server my location\n");
		exit(1);
	}
	wclose(socketfd);
	
	si.sin_family = AF_INET;
	si.sin_port = htons(lport);
	inet_aton("127.0.0.1", &si.sin_addr);
	memset(&(si.sin_zero), '\0', 8);
	
	socketfd = xsocket(PF_INET, SOCK_STREAM, 0);
	xbind(socketfd, (struct sockaddr *) &si, sizeof(si));
	xlisten(socketfd, 1); /* allow a backlog of 1 connection */
	
	mainloop(socketfd);
	return 0;
}


