module GenerateLocationC where

import ParseInitLoc
import Data.Tree

exILI = InitLocInfo (Node rootLocation []) "cur" "cbh" "orig"

-- Given initial location information, generate c code
-- for a location.c to verify it.

{- 
char *get_capplet_origin(char *full_path_to_applet);
char *get_capplet_codebase_host(char *full_path_to_applet);
char *get_capplet_current_location(char *full_path_to_applet);
-}

generateAll ili = 
  (generateOrigin ili) ++ 
  (generateCodeBaseHost ili) ++ 
  (generateCurrentLocation ili)
  
generateOrigin ili = 
  generateLocationFunction 
    "char *get_capplet_origin(char *full_path_to_applet)"
    (iliCodeOrigin ili)

generateCodeBaseHost ili = 
  generateLocationFunction 
    "char *get_capplet_codebase_host(char *full_path_to_applet)" 
	(iliCodeBaseHost ili)

generateCurrentLocation ili = 
  generateLocationFunction
  "char *get_capplet_current_location(char *full_path_to_applet)"
  (iliCurrentLocation ili)

generateLocationFunction functionSig returnVal = 
  functionSig ++ "\n" ++
  "{" ++ "\n" ++
  "\t" ++ "return \"" ++ returnVal ++ "\";" ++ "\n" ++
  "}" ++ "\n\n"




