module Main where 

import System.Environment
import System.Exit
import ParseInitLoc
import GenerateLocationC

main :: IO ()
main = do
  args <- getArgs
  verifyArgsOrQuit args
  let filename = head (args)
  input <- readFile filename
  let locationInit = getInitLocInfo input
  if (args !! 0) == "Main.hs" 
     then putStrLn $ show locationInit
     else case locationInit of 
               Left err -> putStrLn $ show locationInit
               Right x -> putStrLn $ generateAll x


verifyArgsOrQuit :: [String] -> IO ()
verifyArgsOrQuit args = 
  if verifyArgs args
    then putStr ""
	else exitWithBadArgs

exitWithBadArgs :: IO ()
exitWithBadArgs = do
  progName <- getProgName
  putStrLn $ "Use: " ++ progName ++ " location_initialization_file"
  putStrLn $ "See the documentation for an explanation of this file."
  exitWith $ ExitFailure 1

verifyArgs :: [String] -> Bool
verifyArgs args = 
  case length args of 
    1 -> True
    otherwise -> False
  

