#include <stdio.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <string.h>

#include "wrappers.h"
#include "listener.h"

int init_listener(int argc, char **argv) {
	int port, socketfd;
	struct sockaddr_in si;

	if ((argc != 2) && (argc != 3)) {
		printf("Use: %s port [optional-debug-mode]\n", argv[0]);
	 	exit(1);
	}

	port = atoi(argv[1]);
	debug = 0;
	if (argc == 3) debug = 1;

	si.sin_family = AF_INET;
	si.sin_port = htons(port);
	inet_aton("127.0.0.1", &(si.sin_addr));
	memset(&(si.sin_zero), '\0', 8);

	socketfd = xsocket(PF_INET, SOCK_STREAM, 0);
	xbind(socketfd, (struct sockaddr *) &si, sizeof(si));
	xlisten(socketfd, 1); /* allow a backlog of 1 connection */
	return socketfd;
}

