/* This file contains code for querying, at run-time, information such as
where an applet came from.  For static verification, an alternative implementation
which reflects a provided location net is used instead. */

/* Information relevant to a capplet is stored in environment variables:
   ie, the location it was downloaded from is stored as the value of
   ORIGIN/full/path/to/downloaded/applet.
   The environment variables are initialized by the run_capplet
   function.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h> /* memset */


#include "wrappers.h"
#include "cstring.h"

char *get_capplet_origin(char *full_path_to_applet) {
	char *origin, *ret;
	origin = strjoin(2, "ORIGIN", full_path_to_applet);
	//printf("gco: origin is %s\n", origin);
	ret = getenv(origin);
	free(origin);	
	return ret;
}


