/* push-sender is paired with push-recv.
 * It sends a file to the push-recv system listening
 * on the given hostname and port, and then exits.
 */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>

#include "wrappers.h"
#include "filexfer.h"

extern int debug;

int main(int argc, char **argv) {
	char *filename, *host;
	int port, socketfd;
	struct sockaddr_in si;

	if (argc != 4) {
		printf("Use: %s host port filename_to_send\n", argv[0]);
		exit(1);
	}
	
	debug = 1;
	
	host = argv[1];
	port = atoi(argv[2]);
	filename = argv[3];

	si.sin_family = AF_INET;
	si.sin_port = htons(port);
	inet_aton(host, &si.sin_addr); /* FIXME: accept host NAMES too */
	memset(&(si.sin_zero), '\0', 8);

	socketfd = xsocket(PF_INET, SOCK_STREAM, 0);
	xconnect(socketfd, (const struct sockaddr *) &si, sizeof(si));
	send_file(socketfd, filename);
	wclose(socketfd);
								
	return 0;
}


