#!/bin/bash

#GREPCMD="grep -B 10 -A 5 VERIFICATION" 
GREPCMD="grep -A 1 VERIFICATION"

echo "Model-checking sender"
./satabs sender.c wrappers.c | $GREPCMD

echo
echo "Model-checking client"
./satabs client.c wrappers.c  | $GREPCMD

echo
echo "Model-checking push-sender"
./satabs push-sender.c wrappers.c | $GREPCMD

echo
echo "Model-checking push-recv"
./satabs push-recv.c push_recv_core.c wrappers.c | $GREPCMD

# examples
echo
echo "Model checking shopping core"
pushd examples/shopping && make verify | $GREPCMD && popd

echo
echo "Model checking shopping agent with no policy"
pushd examples/shopping/sa_sec_none && make verifynb | $GREPCMD ; popd

echo
echo "Model checking shopping agent with policy with no effect"
pushd examples/shopping/sa_sec_no_effect && make verifynb | $GREPCMD ; popd

echo
echo "Model checking shopping agent with policy sec_a"
pushd examples/shopping/sa_sec_a && make verifynb | $GREPCMD ; popd

echo
echo "Model checking shopping agent with policy sec_b_loc"
pushd examples/shopping/sa_sec_b_loc && make verifynb | $GREPCMD ; popd

echo
echo "Model checking shopping agent with policy sec_b_remote"
pushd examples/shopping/sa_sec_b_remote && make verifynb | $GREPCMD ; popd

echo
echo "Model checking shopping agent with policy sec_c"
pushd examples/shopping/sa_sec_c && make verifynb | $GREPCMD ; popd

echo
echo "Model checking shopping agent with policy sec_c_codebase"
pushd examples/shopping/sa_sec_c_codebase && make verifynb | $GREPCMD ; popd

echo
echo "Model checking update client with no policy"
pushd examples/update/ua_sec_none && make verifynb | $GREPCMD ; popd

echo
echo "Model checking update client with policy a"
pushd examples/update/ua_sec_a && make verifynb | $GREPCMD ; popd

echo
echo "Model checking update client with policy b"
pushd examples/update/ua_sec_b && make verifynb | $GREPCMD ; popd

echo
echo "Model checking update client with policy c"
pushd examples/update/ua_sec_c && make verifynb | $GREPCMD ; popd


